<script setup lang="ts">
import ShowSaleDialogEPM from './User/ShowSaleDialogEPM.vue'
import { onMounted, ref } from 'vue'
import userService from '@/services/user';
import { useAuthStore } from '@/stores/auth';
import { useUserStore } from '@/stores/user';
import { useBranchStore } from '@/stores/branch';

const userStore = useUserStore()
 const authStore = useAuthStore()
 const branchStore = useBranchStore()

 const total_day = ref(0)
 const total_month = ref(0)
 const total_year = ref(0)
 const show = ref<any>(null);
 const title = ref('')
 const branch = ref<{ id: number; name: string }>({ id: 0, name: '' })
 const branchs = ref<{ id: number; name: string }[]>([])


 async function setSales(id:number,by:string){
  if(id){
    const sales = await userService.getSales(id,by)
    console.log(sales)
    total_day.value = sales.data.day
    total_month.value = sales.data.month
    total_year.value = sales.data.year
  }
 }

 function checkRole(){
  branchs.value = branchStore.branches.map((branch) => ({
  id: branch.id ?? -1,
  name: branch.name
}));
  if (authStore.getCurrentUser()!.role.name === "เจ้าของกิจการ") {
    branch.value = {
    id: authStore.getCurrentUser()!.branch.id as number,
    name: authStore.getCurrentUser()!.branch.name
    };
    
  } else if (authStore.getCurrentUser()!.role.name === "ผู้จัดการร้าน") {
    branch.value = {
    id: authStore.getCurrentUser()!.branch.id as number,
    name: authStore.getCurrentUser()!.branch.name
    };
  }
 }

 function showByEmp(){
  show.value = "emp"
  title.value = ""
  setSales(userStore.employee_id,show.value)
  } 

 onMounted(async () => {
  useUserStore().employee_id = useAuthStore().getCurrentUser()?.id
  checkRole()
  showByEmp()
 })
</script>
<template>
  <v-container class="px-6 mt-n2" fluid>
    <v-row>
      <v-col cols="12" sm="4">
        <v-card color="#ab9283" class="rounded-xl" height="130">
          <div>
            <div>
              <v-card-title class="text-h5 mt-6" style="text-align: center;"> ยอดขายประจำวัน </v-card-title>
              <v-card-subtitle class="text-h5" style="text-align: center;">
                {{ total_day }} บาท
              </v-card-subtitle>
            </div>
          </div>
        </v-card>
      </v-col>

      <v-col cols="12" sm="4">
        <v-card color="#ab9283" class="rounded-xl" height="130">
          <div>
            <div>
              <v-card-title class="text-h5 mt-6" style="text-align: center;"> ยอดขายประจำเดือน </v-card-title>
              <v-card-subtitle class="text-h5" style="text-align: center;">{{ total_month }} บาท</v-card-subtitle>
            </div>
          </div>
        </v-card>
      </v-col>

      <v-col cols="12" sm="4">
        <v-card color="#ab9283" class="rounded-xl" height="130">
          <div>
            <div>
              <v-card-title class="text-h5 mt-6" style="text-align: center;"> ยอดขายประจำปี </v-card-title>
              <v-card-subtitle class="text-h5" style="text-align: center;">{{ total_year }} บาท</v-card-subtitle>
            </div>
          </div>
        </v-card>
      </v-col>

      <!-- bar chart -->
      <v-col>
        <v-card class="mx-auto" height="450" style="overflow-y: auto">
          <v-card-item>
            <ShowSaleDialogEPM></ShowSaleDialogEPM>
          </v-card-item>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>

<style scoped>
.mitr-bold {
  font-family: 'Mitr', sans-serif;
  font-weight: 700;
  font-style: normal;
}

.v-card {
  text-align: center;
  font-family: 'Franklin Gothic Medium', 'Arial Narrow', Arial, sans-serif;
  font-size: 70px;
  color: #412f26;
}

.v-sheet,
.v-card {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 80px;
  display: flex;
  justify-content: center;
  align-items: center;
  color: black;
}
</style>
